{ This demo shows how to use the TOpenDialog,
  TSaveDialog, TFindDialog and TReplaceDialog
  components along with the LoadFromFile and
  SaveToFile methods of a TStringList (in this
  case the string list in Memo1). }

unit Main;

interface

uses WinTypes, WinProcs, Classes, Graphics, Controls, Menus,
  Forms, StdCtrls, Dialogs, ExtCtrls,Unit2,Printers;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Memo1: TMemo;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    FindDialog1: TFindDialog;
    Search1: TMenuItem;
    Find1: TMenuItem;
    Replace1: TMenuItem;
    FindNext1: TMenuItem;
    ReplaceDialog1: TReplaceDialog;
    ListBox1: TListBox;
    ListBox2: TListBox;
    Label1: TLabel;
    Label2: TLabel;
    Liste1: TMenuItem;
    effacer1: TMenuItem;
    lister1: TMenuItem;
    N2: TMenuItem;
    sauver1: TMenuItem;
    charger1: TMenuItem;
    Label3: TLabel;
    Label4: TLabel;
    Edition1: TMenuItem;
    Allerligne1: TMenuItem;
    N4: TMenuItem;
    Coller1: TMenuItem;
    Copier1: TMenuItem;
    Couper1: TMenuItem;
    Aide1: TMenuItem;
    Apropos1: TMenuItem;
    N3: TMenuItem;
    mettredansliste1: TMenuItem;
    effacerdelaliste1: TMenuItem;
    Label5: TLabel;
    ListBox3: TListBox;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Label6: TLabel;
    Button9: TButton;
    modifierlment1: TMenuItem;
    Memo2: TMemo;
    N5: TMenuItem;
    Inverser1: TMenuItem;
    N6: TMenuItem;
    statistiques1: TMenuItem;
    caractres1: TMenuItem;
    ColorDialog1: TColorDialog;
    FontDialog1: TFontDialog;
    N7: TMenuItem;
    fond1: TMenuItem;
    plume1: TMenuItem;
    fonte1: TMenuItem;
    Allerligne2: TMenuItem;
    N8: TMenuItem;
    impression1: TMenuItem;
    PrintDialog1: TPrintDialog;
    trouvetexte1: TMenuItem;
    N9: TMenuItem;
    Majuscule1: TMenuItem;
    Minuscule1: TMenuItem;
    N10: TMenuItem;
    Toutslectionner1: TMenuItem;
    N11: TMenuItem;
    gauch1: TMenuItem;
    droite1: TMenuItem;
    centre1: TMenuItem;
    N12: TMenuItem;
    enregistrer1: TMenuItem;
    consulter1: TMenuItem;
    procedure New1Click(Sender: TObject);
    procedure FileOpenClick(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure FileExitClick(Sender: TObject);
    procedure Find1Click(Sender: TObject);
    procedure Find(Sender : TObject);
    procedure FindNext1Click(Sender: TObject);
    procedure Replace1Click(Sender: TObject);
    procedure Replace(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure ListBox1DblClick(Sender: TObject);
    procedure effacer1Click(Sender: TObject);
    procedure lister1Click(Sender: TObject);
    procedure sauver1Click(Sender: TObject);
    procedure charger1Click(Sender: TObject);
    procedure Couper1Click(Sender: TObject);
    procedure Copier1Click(Sender: TObject);
    procedure Coller1Click(Sender: TObject);
    procedure Apropos1Click(Sender: TObject);
    procedure ListBox2DblClick(Sender: TObject);
    procedure Allerligne1Click(Sender: TObject);
    procedure mettredansliste1Click(Sender: TObject);
    procedure effacerdelaliste1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure modifierlment1Click(Sender: TObject);
    procedure Inverser1Click(Sender: TObject);
    procedure caractres1Click(Sender: TObject);
    procedure fond1Click(Sender: TObject);
    procedure plume1Click(Sender: TObject);
    procedure fonte1Click(Sender: TObject);
    procedure Allerligne2Click(Sender: TObject);
    procedure impression1Click(Sender: TObject);
    procedure trouvetexte1Click(Sender: TObject);
    procedure Majuscule1Click(Sender: TObject);
    procedure Minuscule1Click(Sender: TObject);
    procedure Toutslectionner1Click(Sender: TObject);
    procedure droite1Click(Sender: TObject);
    procedure gauch1Click(Sender: TObject);
    procedure centre1Click(Sender: TObject);
    procedure enregistrer1Click(Sender: TObject);
    procedure consulter1Click(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

uses SysUtils, Search;

{$R *.DFM}

procedure TForm1.New1Click(Sender: TObject);
begin
  Memo1.Clear;
  OpenDialog1.Filename := '';
  Caption := 'Editeur - [Untitled]';
end;

procedure TForm1.FileOpenClick(Sender: TObject);
begin
  with OpenDialog1 do
    if Execute then
    begin
      Memo1.Lines.LoadFromFile(FileName);
      Caption := 'Editeur - ' + ExtractFilename(FileName);
      ListBox1.items.add(FileName);
    end;
end;

procedure TForm1.Save1Click(Sender: TObject);
begin
  if OpenDialog1.Filename <> '' then
  begin
    Memo1.Lines.SaveToFile(OpenDialog1.Filename);
  end
  else SaveAs1Click(Sender);
end;

procedure TForm1.SaveAs1Click(Sender: TObject);
begin
  with SaveDialog1 do
    if Execute then
    begin
      Memo1.Lines.SaveToFile(Filename);
      Caption := 'Editeur - ' + ExtractFilename(FileName);
      OpenDialog1.Filename := Filename;
    end;
end;

procedure TForm1.Find1Click(Sender: TObject);
begin
  FindDialog1.Execute;
  FindNext1.Enabled := True;
end;

procedure TForm1.Find(Sender: TObject);
begin
  with Sender as TFindDialog do
    if not SearchMemo(Memo1, FindText, Options) then
      ShowMessage('Non trouv "' + FindText + '".');
end;

procedure TForm1.Replace1Click(Sender: TObject);
begin
  ReplaceDialog1.Execute;
end;

procedure TForm1.FindNext1Click(Sender: TObject);
begin
  Find(FindDialog1);
end;

{ Replace and ReplaceAll call this routine. }
procedure TForm1.Replace(Sender: TObject);
var
  Found: Boolean;
begin
  with ReplaceDialog1 do
  begin
    if AnsiCompareText(Memo1.SelText, FindText) = 0 then
      Memo1.SelText := ReplaceText;
    Found := SearchMemo(Memo1, FindText, Options);
    while Found and (frReplaceAll in Options) do
    begin
      Memo1.SelText := ReplaceText;
      Found := SearchMemo(Memo1, FindText, Options);
    end;
    if (not Found) and (frReplace in Options) then
      ShowMessage('Non trouv "' + FindText + '".');
  end;
end;

procedure TForm1.FileExitClick(Sender: TObject);
var
  MsgResult: Word;
  CanClose : boolean;
begin
  if Memo1.Modified then
     MsgResult := MessageDlg(Format('Fichier %s a t modifi. Sauver fichier?',
    [OpenDialog1.Filename]), mtWarning, mbYesNoCancel, 0);
  case MsgResult of
    mrYes:
      begin
        Saveas1Click(Sender);
        CanClose := True;
      end;
    mrNo: CanClose := True;
    mrCancel: CanClose := False;
  end;
  if CanClose then close;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  MsgResult: Word;
begin
  if Memo1.Modified then
    MsgResult := MessageDlg(Format('Fichier %s a t modifi. Sauver fichier?',
    [OpenDialog1.Filename]), mtWarning, mbYesNoCancel, 0);
  case MsgResult of
    mrYes:
      begin
        Save1Click(Sender);
        CanClose := True;
      end;
    mrNo: CanClose := True;
    mrCancel: CanClose := False;
  end;
end;

procedure TForm1.ListBox1DblClick(Sender: TObject);
var FileName: string;

begin
      FileName:=ListBox1.Items[ListBox1.ItemIndex];
      Memo1.Lines.LoadFromFile(FileName);
      opendialog1.filename:=filename;
      Caption := 'Editeur - ' + ExtractFilename(FileName);
      ListBox1.items.add(FileName);

end;

procedure TForm1.effacer1Click(Sender: TObject);
begin
     ListBox2.items.clear;
     Label4.Caption:='0';
end;

procedure TForm1.lister1Click(Sender: TObject);
var nbmot : integer;
    trouv,nvligne : string;
    c : char;
    i,index,ligne : integer;
begin
nbmot:=0;
Showmessage(IntToStr(Memo1.Lines.count) + ' lignes');
for ligne:=0 to  Memo1.Lines.Count-1 do
begin

    i:=1;
    index:=1;
    nvligne:=Memo1.Lines[ligne];
    while (i<Length(nvligne))  do
    begin
    c:= nvligne[i];
    case c of
      'a'..'z', 'A'..'Z', '0'..'9','','','','','','','','','','','','' : i:=i+1;
      else
        begin
         if index< i then
           begin
             trouv := copy(nvligne,index,i-index);
             {Label1.Caption:=IntToStr(ListBox2.items.indexOf(trouv));}
             if (ListBox2.items.indexOf(trouv)=-1) then
                      begin
                           ListBox2.items.add(trouv);
                           nbmot:=nbmot+1;
                      end;
           end;
         i:=i+1;
         index:=i;
        end;
      end;
    end;
  if index< i then
           begin
             if not(nvligne[i] in [',',';','.','!','?',':',')',']','-']) then
               trouv := copy(nvligne,index,i+1-index)
              else
              trouv := copy(nvligne,index,i-index);
             {Label1.Caption:=IntToStr(ListBox2.items.indexOf(trouv));}
             if (ListBox2.items.indexOf(trouv)=-1) then
                      begin
                           ListBox2.items.add(trouv);
                           nbmot:=nbmot+1;
                      end;
           end;
end;
  Label4.Caption:=IntToStr(nbmot);
end;

procedure TForm1.sauver1Click(Sender: TObject);
begin
with SaveDialog1 do
    if Execute then
    begin
      ListBox2.items.SaveToFile(FileName);
      Caption := 'Text Demo - ' + ExtractFilename(FileName);
      OpenDialog1.Filename := Filename;
    end;

end;

procedure TForm1.charger1Click(Sender: TObject);
begin
with OpenDialog1 do
    if Execute then
    begin
         try
            ListBox2.items.LoadFromFile(filename);
            Label4.Caption:=IntToStr(ListBox2.items.Count);
         except
             ListBox2.items.Clear;
             MessageDlg('Saisissez du texte dans le contrle list',
             mtInformation, [mbOk], 0 );
         end;
    end;
end;

procedure TForm1.Couper1Click(Sender: TObject);
begin
     Memo1.CutToClipboard;
end;

procedure TForm1.Copier1Click(Sender: TObject);
begin
     Memo1.CopyToClipboard;
end;

procedure TForm1.Coller1Click(Sender: TObject);
begin
     Memo1.PasteFromClipboard;
end;

procedure TForm1.Apropos1Click(Sender: TObject);
begin

     BtnBottomDlg.show;
end;

procedure TForm1.ListBox2DblClick(Sender: TObject);
var s : string;
begin
 s:=ListBox2.items[ListBox2.ItemIndex];
 (*Memo1.Text:=copy(Memo1.Text,1,SelStart)+s+copy(Memo1.Text,SelStart+1,Memo);*)
 Memo1.SelText:=s;
end;

procedure TForm1.Allerligne1Click(Sender: TObject);
var gos: string;
begin
  gos:=inputbox('Aller au caractre','Saisissez le numro du caractre','');
  if gos<>'' then
    Memo1.SelStart:=StrToInt(gos);
end;

procedure TForm1.mettredansliste1Click(Sender: TObject);
begin
     ListBox2.items.add(copy(Memo1.Text,Memo1.Selstart+1,Memo1.SelLength));
end;

procedure TForm1.effacerdelaliste1Click(Sender: TObject);
begin
     ListBox2.Items.Delete(Listbox2.ItemIndex);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
   ListBox3.items.add(ListBox2.Items[ListBox2.ItemIndex]);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
   ListBox2.items.add(ListBox3.Items[ListBox3.ItemIndex]);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
   ListBox3.Items.Clear;
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
 ListBox3.sorted:=not ListBox3.sorted;
end;

procedure TForm1.Button6Click(Sender: TObject);
var pos : integer;
begin
  pos:=ListBox3.Itemindex;
  if pos>0 then
   ListBox3.Items.Move(pos, pos-1);
  ListBox3.setfocus;
  ListBox3.itemIndex:=pos-1;
end;

procedure TForm1.Button7Click(Sender: TObject);
var pos : integer;
begin
  pos:=ListBox3.Itemindex;
  if pos<(ListBox3.Items.count-1) then
   ListBox3.Items.Move(pos, pos+1);
  ListBox3.setfocus;
  ListBox3.itemIndex:=pos+1;
end;

procedure TForm1.Button5Click(Sender: TObject);
var i : integer;
begin
  for i:=0 to ListBox2.Items.Count-1 do
   ListBox3.Items.add(ListBox2.Items[i]);
end;

procedure TForm1.Button4Click(Sender: TObject);
var i : integer;
begin
(*showmessage(IntToStr(ListBox3.Items.Count));*)
  for i:=0 to ListBox3.Items.Count-1 do
   ListBox2.Items.add(ListBox3.Items[i]);

end;

procedure TForm1.Button9Click(Sender: TObject);
begin
    ListBox3.Items.Delete(Listbox3.ItemIndex);
end;

procedure TForm1.modifierlment1Click(Sender: TObject);
var gos : string;
    pos : integer;
begin
  gos:=inputbox('Modifier '+ListBox2.Items[Listbox2.ItemIndex],'Saisissez le texte','');
  if gos<>'' then
  begin
     pos:= Listbox2.ItemIndex;
     ListBox2.Items.Delete(Listbox2.ItemIndex);
     ListBox2.Items.add(gos);
     ListBox2.ItemIndex:=pos;
  end;
end;

procedure TForm1.Inverser1Click(Sender: TObject);
var pos,nb : integer;
begin
     Memo2.Clear;
     nb:=Memo1.Lines.Count-1;
     showmessage(IntToStr(nb));
     for pos:=0 to nb do
       begin
       (*showmessage( Memo1.lines[pos]);*)
       Memo2.lines.add(Memo1.lines[pos]);
       end;
     Memo1.Clear;

     for pos:=0 to nb do
       Memo1.lines.add(Memo2.lines[nb-pos]);

end;

procedure TForm1.caractres1Click(Sender: TObject);
var tablettre : array [1..256] of integer;
    s : string;
    i,j,num : integer;
    c : char;
begin
for i:=1 to 256 do
    tablettre[i]:=0;
     for j:=0 to Memo1.Lines.Count-1 do
     begin
       s:=Memo1.Lines[j];
       for i:=1 to length(s) do
       begin
        num:=integer(ord(s[i]));
        tablettre[num+1]:=tablettre[num+1]+1;
       end;
     end;
     ListBox3.Clear;

     for i:=33 to 256 do
       ListBox3.Items.add(IntToStr(i-1)+'='+char(i-1)+' : '+IntToStr(tablettre[i]));
end;

procedure TForm1.fond1Click(Sender: TObject);
begin
    if  ColorDialog1.execute then
        Memo1.Color:=ColorDialog1.Color;
end;

procedure TForm1.plume1Click(Sender: TObject);
begin
 if  ColorDialog1.execute then
        Memo1.Font.Color:=ColorDialog1.Color;
end;

procedure TForm1.fonte1Click(Sender: TObject);
begin
 if FontDialog1.execute then
    begin
      Memo1.Font:=FontDialog1.Font;


    end;
end;

procedure TForm1.Allerligne2Click(Sender: TObject);
var gos: string;
frdown : TFindoptions;
begin
  gos:=inputbox('Aller  la ligne','Saisissez le numro de la ligne','');
  if gos<>'' then
  begin
    (*ShowMessage(Memo1.Lines[strtoint(gos)-1]);*)
    (*SearchMemo(Memo1,Memo1.Lines[StrToInt(gos)-1],frdown);*)
     ReplaceDialog1.FindText:=Memo1.Lines[strtoint(gos)-1];
    (*ReplaceDialog1.Options:=frFindNext;*)
    ReplaceDialog1.execute;
  end;

end;

procedure TForm1.impression1Click(Sender: TObject);
var f : System.Text;
    i : integer;
begin
     if PrintDialog1.execute then
     begin
     AssignPrn(f);
     rewrite(f);
     for i:=1 to Memo1.Lines.count-1 do
         writeln(f,Memo1.Lines[i]);
     System.close(f);
     end;
     (*PrintDialog1.execute;*)
end;

procedure TForm1.trouvetexte1Click(Sender: TObject);
var gos : string;
    pos : integer;
begin

     pos:= Listbox2.ItemIndex;
     gos:=ListBox2.Items[pos];
     ReplaceDialog1.FindText:=gos;
     ReplaceDialog1.execute;
end;

procedure TForm1.Majuscule1Click(Sender: TObject);
begin
 memo1.SelText:=Uppercase(Memo1.Seltext);
end;

procedure TForm1.Minuscule1Click(Sender: TObject);
begin
     memo1.SelText:=Lowercase(Memo1.Seltext);
end;

procedure TForm1.Toutslectionner1Click(Sender: TObject);
begin
     Memo1.SelectAll;
end;

procedure TForm1.droite1Click(Sender: TObject);
begin
     Memo1.Alignment := taRightJustify;
end;

procedure TForm1.gauch1Click(Sender: TObject);
begin
     Memo1.Alignment := taLeftJustify;
end;

procedure TForm1.centre1Click(Sender: TObject);
begin
     Memo1.Alignment := taCenter;
end;

procedure TForm1.enregistrer1Click(Sender: TObject);
var nomFic,ligne : string;
    monFic : TextFile;
    tablettre : array [1..256] of integer;
    s : string;
    i,j,num : integer;
    c : char;
begin
   ligne:='';
   nomFic := inputBox('Nom du fichier','entrer le nom du fichier',OpenDialog1.Filename);
   if nomFic='' then exit;
   ligne:=nomFic+',';
   for i:=1 to 256 do
    tablettre[i]:=0;
     for j:=0 to Memo1.Lines.Count-1 do
     begin
       s:=Memo1.Lines[j];
       for i:=1 to length(s) do
       begin
        num:=integer(ord(s[i]));
        tablettre[num+1]:=tablettre[num+1]+1;
       end;
     end;

     AssignFile(MonFic,'c:\statysty.mor');
     try
        Append(monFic);
     except
        on EInOutError DO Rewrite(monFic);
     end;
      write(monFic,ligne);
      for i:=33 to 255 do
        write(monFic,IntToStr(tablettre[i])+',');
      write(monFic,IntToStr(tablettre[256]));
      writeln(monFic,'');  
      closefile(monfic);
      

end;

procedure TForm1.consulter1Click(Sender: TObject);
 var canclose : boolean;
 begin
    canclose:=true;
    if Memo1.modified then
        FormCloseQuery(self,canclose);

    if canclose then
    begin
    openDialog1.Filename:='C:\statysty.mor';
    if openDialog1.Execute then
    begin
      Memo1.Lines.LoadFromFile(openDialog1.FileName);
      Caption := 'Editeur - ' + ExtractFilename(opendialog1.FileName);
      ListBox1.items.add(opendialog1.FileName);
    end;
    end;
end;

end.
